<div class='row container pb-5 rule_list_class' style="margin-right: 0em;">
    <div class='col-9 pt-2 pb-3 v1'>
        <button class="btn btn-sm mb-2 mr-2" title="{{ruleContent?.Overview}}" (click)="omodalDlgOpen()">
            <em class="ml-3 fas fa-clipboard-list"></em></button>
        <button class="btn btn-sm mb-2 " title="{{ruleContent?.RuleGuide}}" disabled=true><img
                src="assets/images/Rule Guide.png" height="15" alt="{{ruleContent?.RuleGuide}}"/></button>

<!-- -------------------------------------- For editing START -------------------------------------- -->

        <div *ngFor="let item of rule_complete_data; let id = index" class='card bg-light mb-2'>
             <!-- ------------- RULE Card HEADER start ------------- -->
            <div class="card-header pt-0 pb-0">
                <!-- _____________ RULE NAME non edit mode start ________________ -->
                <div class='row mt-2 mb-2'>
                    <div *ngIf="!item.canEditCode" class="col text-left my-auto"><strong>{{ruleContent?.RuleName}}</strong>{{item.rule_name}}</div>
                    <div *ngIf="!item.canEditCode" class="col text-right my-auto">
                        <strong><button ejs-button type="button" class="no-border fas fa-pencil-alt"
                                (click)="item.canEditCode = true;setEditflag(true);"
                                [disabled]="only_single_rule_edit"></button></strong>
                        <strong><button ejs-button type="button" class="no-border far fa-trash-alt"
                                (click)="ruleDeletewarning(item.rule_id)"
                                [disabled]="only_single_rule_edit"></button></strong>
                    </div>
                </div>
                <!-- _____________ RULE NAME non edit mode end ________________ -->
                <!-- _____________ RULE NAME edit mode start ________________ -->
                <div class='row mt-2 mb-2'>
                    <div *ngIf="item.canEditCode" class="col text-left text-nowrap my-auto d-inline-flex"><strong>{{ruleContent?.RuleName}}</strong>
                        <div class="col text-left my-auto pr-0">
                            <input class="form-control h-auto pt-0 pb-0" *ngIf="item.canEditCode" [(ngModel)]="item.rule_name" type="text" />
                        </div>
                    </div>
                    <div *ngIf="item.canEditCode" class="col text-right my-auto">
                        <strong><button ejs-button type="button" class="no-border fa fa-save"
                                (click)="SaveEditRule(item.rule_id,item.rule_name,item.output);"></button></strong>
                        <strong><button ejs-button type="button" class="no-border fa fa-times" (click)="dontSaveEditRule();"></button></strong>
                        <strong><button ejs-button type="button" class="no-border far fa-trash-alt"
                                (click)="ruleDeletewarning(item.rule_id)"></button></strong>
                    </div>
                </div>
                <!-- _____________ RULE NAME edit mode end ________________ -->
            </div>
            <!-- ------------- RULE Card HEADER end ------------- -->
            <div class='card-body pt-0 pb-0'>
            <!-- ------------- RULE Card BODY start ------------- -->
                <div class="card-text">
                    <!-------------  Input and Output field start ------------->
                    <div class='row mt-1'>
                        <div class="col my-auto d-inline-flex">
                            <label class="rule_page_font_size text-nowrap my-auto"><strong>{{ruleContent?.OutputName}}&nbsp;</strong></label>
                            <span *ngIf="!item.canEditCode">{{item.output}}</span>
                            <input *ngIf="item.canEditCode" [(ngModel)]="item.output" type="text"
                                class="form-control mb-2 mt-2 h-auto pt-0 pb-0" />
                        </div>
                        <div class="col my-auto">
                            <label class="rule_page_font_size"><strong>{{ruleContent?.Input}}&nbsp;</strong></label><span>{{item.input}}</span>
                        </div>
                    </div>
                    <!-------------  Input and Output field end ------------->
                    <!------------- User rule input start ------------->
                    <div class='row mt-1'>
                        <div class='col-9 d-inline-flex'>
                            <label class="rule_page_font_size align-top text-nowrap"><strong>{{ruleContent?.Rule}}&nbsp;</strong></label>
                            <span *ngIf="!item.canEditCode text-nowrap" class="mb-2">{{item.user_input}}</span>
                            <textarea [attr.id]="'userinput_' + id"  #ruleInput *ngIf="item.canEditCode" [(ngModel)]="item.user_input"
                                type="text" class="form-control mb-2" (click)="getCaretPos(ruleInput)" (keyup)="getCaretPos(ruleInput)"></textarea>
                        </div>
                        <div class=' col-3 my-auto card border-danger' *ngIf='error_variable.error_switch && item.canEditCode'>
                            <div class="card-title text-danger">
                                <em class="fa fa-exclamation-triangle"></em> 
                                <strong> &nbsp; {{ruleContent?.Error}}</strong>
                            </div>
                            <div class ="card-body text-danger pt-0 pb-0" [innerHTML]=error_variable.error_message></div>
                        </div>  
                    </div>
                    <!------------- User rule input end ------------->
                </div>
            </div>
            <!-- ------------- RULE Card BODY end ------------- -->
        </div>

<!-- -------------------------------------- For editing END -------------------------------------- -->

<!-- -------------------------------------- For Adding Rule START -------------------------------------- -->

        <div class='card-body card bg-light mb-2 pt-0 pb-0' *ngIf='!only_single_rule_edit'>
            <div class="card-text">
                <strong><div>{{ruleContent?.AddRule}}</div></strong>
                <div class='row'>
                    <div class='col-9'>
                    <form #ruleform="ngForm">
                        <div class="form-group form-group-lg mb-0">
                            <label class="rule_page_font_size">{{ruleContent?.EnterRuleName}} 
                                <span class="required">*</span></label>
                            <input type="text" class="form-control h-auto pt-0 pb-0 text-nowrap my-auto d-inline-flex" #nameval='ngModel' required name='rule_name'
                                [(ngModel)]="rule_name">
                            <div *ngIf="(nameval.invalid && (nameval.dirty || nameval.touched))">
                                <div class="e-error" *ngIf="nameval.errors.required">
                                    {{ruleContent?.RuleNameRequired}}
                                </div>
                            </div>
                        </div>
                        <div class="form-group form-group-lg mb-0">
                            <label class="rule_page_font_size h-auto pt-0 pb-0"> {{ruleContent?.OutputTableName}}<span
                                    class="required">*</span></label>
                            <input type="text" class="form-control h-auto pt-0 pb-0 text-nowrap my-auto d-inline-flex" #outputval='ngModel' required name='output'
                                [(ngModel)]="output" [disabled]="screenId == 'validation'">
                            <ejs-tooltip class="rules-info-icon d-inline-flex" content={{ruleContent?.ToolTipInfo1}} position='RightCenter'>
                                <img class='info-icon pl-2'  alt="Avatar" src="assets/images/featureicons/info.svg">
                            </ejs-tooltip>
                            <div class="rule_page_font_size"
                                *ngIf="(outputval.invalid && (outputval.dirty || outputval.touched))">
                                <div class="e-error" *ngIf="outputval.errors.required">
                                    {{ruleContent?.OutputTableNameRequired}}
                                </div>
                            </div>
                        </div>
                        <div class="form-group form-group-lg mb-0">
                            <label class="rule_page_font_size">{{ruleContent?.EnterRule}} <span
                                    class="required">*</span></label>
                            <textarea type="text" id="add_rule" #ruleInput class="form-control d-inline-flex" #rulevar='ngModel' required
                                name='rules' [(ngModel)]="rules_user_input" rows="3" (click)="getCaretPos(ruleInput)" (keyup)="getCaretPos(ruleInput)"></textarea>
                            <ejs-tooltip class="rules-info-icon d-inline-flex" content={{ruleContent?.ToolTipInfo2}} position='RightCenter'>
                                <img class='info-icon pl-2'  alt="Avatar" src="assets/images/featureicons/info.svg">
                            </ejs-tooltip>
                            <!-- ___________________ Dont delete will be used in future ___________________ -->
                            <!-- <p class='orgRules' appHighlight [searchedWords]="right_kword" [text]="rules" classToApply="selected"></p> -->
                            <!-- ___________________ Dont delete will be used in future ___________________ -->
                            <div *ngIf="(rulevar.invalid && (rulevar.dirty))">
                                <div class="e-error" *ngIf="rulevar.errors.required">
                                    {{ruleContent?.RuleRequired}}
                                </div>
                            </div>
                            <br>
                            <span *ngFor="let pill of pills; index as i;"
                                class="cursor-pointer m-1 e-badge e-badge-secondary e-badge-pill"
                                [ngClass]="{'e-badge-ghost' : selected != i}"
                                (click)="selected=i;selectPill(pill)">{{pill.component_name}}</span>
                            <div *ngIf="phrases?.length > 0" class="m-1"><small>{{ruleContent?.Example}}
                                    <div *ngFor="let phrase of phrases" (click)="selectPhrase(phrase)"
                                        class="cursor-pointer">{{phrase}}</div>
                                </small></div>
                        </div>
                    </form>
                    </div>
                    <div class='col-3 my-auto card border-danger' *ngIf='error_variable.error_switch && !only_single_rule_edit'>
                        <div class="card-title text-danger">
                            <em class="fa fa-exclamation-triangle"></em> 
                            <strong> &nbsp; {{ruleContent?.Error}}</strong>
                        </div>
                        <div class ="card-body text-danger pt-0 pb-0" [innerHTML]=error_variable?.error_message></div>
                    </div>
                </div>
                <button ejs-button class="btn btn-dark btn-sm mr-1 ml-1 e-btn mb-1" [disabled]="ruleform.invalid"
                    (click)="addrules() ">{{ruleContent?.Add}}</button>
            </div>
        </div>
    </div>
<!-- -------------------------------------- For Adding Rule END -------------------------------------- -->

    <div class='col-3 contain_dataset_params'>
        <div class='row available_dataset_class'>
            <div class="control_wrapper overflow-auto">
                <div class="adapter_style">{{ruleContent?.AvailableDatasets}}</div>

                <div>
                    <ejs-treeview #tree [fields]='field' (nodeClicked)='fieldSelected($event)'></ejs-treeview>
                </div>
            </div>
        </div>

        <!-- parameters section -->
        <div class='row pt-2 parameter_class'>
            <div class="col-md-4 ">
                <div class="para_style"> {{ruleContent?.Parameters}}</div>
            </div>

            <div class="col-md-2 offset-md-6">
                <button ejs-button type="button" class="btn" (click)="pmodalDlgOpen()"><em
                        class="fa fa-asterisk"></em> </button>

                <!-- Dialog open -->
                <ejs-dialog #parameterDialog [visible]='false' [showCloseIcon]='true' width=1200 isModal="true"
                    height=500 (close)="paraModalDlgClose()" (open)="paraModalDlgOpen()">

                    <ng-template #content>
                        <div *ngIf="paramshow">
                            <app-parameters [screenId]="screenId" (childEvent)="make_data_request()"
                                [parameters]="parameters">
                            </app-parameters>
                        </div>
                    </ng-template>

                    <ng-template #header>
                        <div title="{{ruleContent?.ParameterProperties}}" class="e-icon-settings dlg-template">
                            {{ruleContent?.ParameterProperties}}
                        </div>
                    </ng-template>

                </ejs-dialog>
            </div>


            <!-- parameters on rule set page -->

            <div>

                <p *ngIf="parameters.length==0" [innerHTML]="ruleContent?.PlaceholderText"></p>

                <ejs-grid *ngIf="parameters.length!=0" #gridelement [dataSource]='parameters'>
                    <e-columns>
                        <e-column field='name' headerText="{{ruleContent?.ParameterHeaderRule}}" width=130></e-column>
                        <e-column field='config_type' headerText='{{ruleContent?.ParameterTypeHeaderRule}}' width=130>
                        </e-column>

                    </e-columns>
                </ejs-grid>
            </div>


        </div>
    </div>
</div>

<ejs-dialog #overviewDialog [visible]='false' [showCloseIcon]='true' width=900 isModal="true" height=500
    (close)="modalDlgClose()" (open)="modalDlgOpen()">
    <ng-template #content>
        <div *ngIf="show">
            <app-overview [workflow_data]="workflow_data"></app-overview>
        </div>
    </ng-template>
    <ng-template #header>
        <div title="{{ruleContent?.Overview}}" class="e-icon-settings dlg-template"> {{ruleContent?.Overview}} </div>
    </ng-template>
</ejs-dialog>

<!-- Pop up for delete Rule warning  -->
<ejs-dialog id="deleterulewarning" isModal="true" #deleterulewarning width='450px' (open)="modalDlgOpen()"
    (close)="modalDlgClose()" [visible]='false' showCloseIcon='true' target='.control-section'>
    <ng-template #header>{{ruleContent?.DeleteRule}}</ng-template>
    <ng-template #content>
        <p>{{ruleContent?.DeleteRuleStatment}}</p>
        <button ejs-button class="btn btn-dark btn-sm mr-1 ml-1 e-btn mb-1" (click)="ruleDelete() ">{{ruleContent?.Yes}}</button>
        <button ejs-button class="btn btn-dark btn-sm mr-1 ml-1 e-btn mb-1" (click)="dontdelterule() ">{{ruleContent?.No}}</button>
    </ng-template>
</ejs-dialog>